#ifndef AFX_LZHTOOL_H__31F8AA01_3F84_11D4_8D96_8AB5A6462337__INCLUDED_
#define AFX_LZHTOOL_H__31F8AA01_3F84_11D4_8D96_8AB5A6462337__INCLUDED_

#include "Tool.h"

class CLzhTool : public CTool
{
//
// see LzhDecoder2.h
//

public:
	CLzhTool() : CTool( "Lzh " )
	{
		// CRCe[u
		for( WORD i=0,j,r; i!=256; i++ )
		{
			r = i;
			for( j=0; j!=8; j++ )
			{
				if( r&1 ) r = ((r>>1)^0xA001);//CRCPOLY
				else	  r>>=1;
			}
			crctable[i] = r;
		}
	}

	bool IsType( const char* ext )
		{return 0==stricmp(ext,"lzh");}

	bool Check( const char* fname, unsigned long fsize );
	bool Extract( const char* fname, const char* ddir );

private:
	int FindHeader( const char* fname, const BYTE* hdr, DWORD siz );
	bool ReadHeader( unsigned char* buf );

	WORD crctable[256];
	WORD crc;
	BYTE sum;
	void UpdateCRC( BYTE *p,int n )
		{while( n-- )crc = crctable[(crc^(*p++))&0xff] ^ (crc >> 8);}
	void UpdateSum( BYTE *p,int n )
		{while( n-- )sum+=*(p++);}
	int  fread_crc( BYTE* p,int n)
		{n=fread(p,1,n,lzh);if(n==-1)n=0;
		UpdateCRC(p,n);UpdateSum(p,n);return n;}

// ݏ̊i[t@C̏񂪃oɓ
	FILE *lzh,*out;

	BYTE  h_Level;					// wb_x
	char  h_FileName[MAX_PATH*2];	// t@C(pXt)
	char  h_Method[6];				// k@ "-lh5-" ȂǁB
	DWORD h_CompSize;				// kꂽTCY
	DWORD h_OrigSize;				// ̃TCY
	WORD  h_Attrib;					// 
	DWORD h_Update;					// XV(h0,h1:ftime  h2:time_t)
};

#endif
